//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: secret/registration/v1beta1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service
///
/// Usage: instantiate `Secret_Registration_V1beta1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Secret_Registration_V1beta1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Secret_Registration_V1beta1_QueryClientInterceptorFactoryProtocol? { get }

  func txKey(
    _ request: SwiftProtobuf.Google_Protobuf_Empty,
    callOptions: CallOptions?
  ) -> UnaryCall<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>

  func registrationKey(
    _ request: SwiftProtobuf.Google_Protobuf_Empty,
    callOptions: CallOptions?
  ) -> UnaryCall<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>

  func encryptedSeed(
    _ request: Secret_Registration_V1beta1_QueryEncryptedSeedRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Secret_Registration_V1beta1_QueryEncryptedSeedRequest, Secret_Registration_V1beta1_QueryEncryptedSeedResponse>
}

extension Secret_Registration_V1beta1_QueryClientProtocol {
  internal var serviceName: String {
    return "secret.registration.v1beta1.Query"
  }

  /// Returns the key used for transactions
  ///
  /// - Parameters:
  ///   - request: Request to send to TxKey.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func txKey(
    _ request: SwiftProtobuf.Google_Protobuf_Empty,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key> {
    return self.makeUnaryCall(
      path: "/secret.registration.v1beta1.Query/TxKey",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeTxKeyInterceptors() ?? []
    )
  }

  /// Returns the key used for registration
  ///
  /// - Parameters:
  ///   - request: Request to send to RegistrationKey.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func registrationKey(
    _ request: SwiftProtobuf.Google_Protobuf_Empty,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key> {
    return self.makeUnaryCall(
      path: "/secret.registration.v1beta1.Query/RegistrationKey",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeRegistrationKeyInterceptors() ?? []
    )
  }

  /// Returns the encrypted seed for a registered node by public key
  ///
  /// - Parameters:
  ///   - request: Request to send to EncryptedSeed.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func encryptedSeed(
    _ request: Secret_Registration_V1beta1_QueryEncryptedSeedRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Secret_Registration_V1beta1_QueryEncryptedSeedRequest, Secret_Registration_V1beta1_QueryEncryptedSeedResponse> {
    return self.makeUnaryCall(
      path: "/secret.registration.v1beta1.Query/EncryptedSeed",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEncryptedSeedInterceptors() ?? []
    )
  }
}

internal protocol Secret_Registration_V1beta1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'txKey'.
  func makeTxKeyInterceptors() -> [ClientInterceptor<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>]

  /// - Returns: Interceptors to use when invoking 'registrationKey'.
  func makeRegistrationKeyInterceptors() -> [ClientInterceptor<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>]

  /// - Returns: Interceptors to use when invoking 'encryptedSeed'.
  func makeEncryptedSeedInterceptors() -> [ClientInterceptor<Secret_Registration_V1beta1_QueryEncryptedSeedRequest, Secret_Registration_V1beta1_QueryEncryptedSeedResponse>]
}

internal final class Secret_Registration_V1beta1_QueryClient: Secret_Registration_V1beta1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Secret_Registration_V1beta1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the secret.registration.v1beta1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Secret_Registration_V1beta1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Secret_Registration_V1beta1_QueryProvider: CallHandlerProvider {
  var interceptors: Secret_Registration_V1beta1_QueryServerInterceptorFactoryProtocol? { get }

  /// Returns the key used for transactions
  func txKey(request: SwiftProtobuf.Google_Protobuf_Empty, context: StatusOnlyCallContext) -> EventLoopFuture<Secret_Registration_V1beta1_Key>

  /// Returns the key used for registration
  func registrationKey(request: SwiftProtobuf.Google_Protobuf_Empty, context: StatusOnlyCallContext) -> EventLoopFuture<Secret_Registration_V1beta1_Key>

  /// Returns the encrypted seed for a registered node by public key
  func encryptedSeed(request: Secret_Registration_V1beta1_QueryEncryptedSeedRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Secret_Registration_V1beta1_QueryEncryptedSeedResponse>
}

extension Secret_Registration_V1beta1_QueryProvider {
  internal var serviceName: Substring { return "secret.registration.v1beta1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "TxKey":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<SwiftProtobuf.Google_Protobuf_Empty>(),
        responseSerializer: ProtobufSerializer<Secret_Registration_V1beta1_Key>(),
        interceptors: self.interceptors?.makeTxKeyInterceptors() ?? [],
        userFunction: self.txKey(request:context:)
      )

    case "RegistrationKey":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<SwiftProtobuf.Google_Protobuf_Empty>(),
        responseSerializer: ProtobufSerializer<Secret_Registration_V1beta1_Key>(),
        interceptors: self.interceptors?.makeRegistrationKeyInterceptors() ?? [],
        userFunction: self.registrationKey(request:context:)
      )

    case "EncryptedSeed":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Secret_Registration_V1beta1_QueryEncryptedSeedRequest>(),
        responseSerializer: ProtobufSerializer<Secret_Registration_V1beta1_QueryEncryptedSeedResponse>(),
        interceptors: self.interceptors?.makeEncryptedSeedInterceptors() ?? [],
        userFunction: self.encryptedSeed(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Secret_Registration_V1beta1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'txKey'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeTxKeyInterceptors() -> [ServerInterceptor<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>]

  /// - Returns: Interceptors to use when handling 'registrationKey'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeRegistrationKeyInterceptors() -> [ServerInterceptor<SwiftProtobuf.Google_Protobuf_Empty, Secret_Registration_V1beta1_Key>]

  /// - Returns: Interceptors to use when handling 'encryptedSeed'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEncryptedSeedInterceptors() -> [ServerInterceptor<Secret_Registration_V1beta1_QueryEncryptedSeedRequest, Secret_Registration_V1beta1_QueryEncryptedSeedResponse>]
}
